<?php

namespace App\Models;

use Illuminate\Support\Str;

use Spatie\Permission\Traits\HasRoles;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Deligoez\LaravelModelHashId\Traits\HasHashId;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Equipment extends Model
{
    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable, HasHashId, HasRoles, SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $guarded = [];

    /**
     * Relations
     */

    // Produit associé à l'équipement
    public function product()
    {
        return $this->belongsTo(Product::class);
    }

    // Utilisateur qui a créé l'équipement
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    // Département auquel appartient l'équipement
    public function department()
    {
        return $this->belongsTo(Department::class);
    }

    //Génération automatique de la référence unique pour les équipements
    protected static function booted()
    {
        static::creating(function ($equipment) {
            $equipment->reference = 'EQP-00' . strtoupper(Str::random(2));
        });
    }
}